# -*- coding: UTF-8 -*-
#   icd_cur_mdl_opr.py    2020.6.2  kita
#!! アクティブモデルファイルを操作する Script
#       削除(c:\IACDSX\GOMIへ移動),copy,読み取り属性解除　ectする


# 起動方法
# py icd_cur_mdl_opr.py


#   必要なファイル
#   icd_cur_mdl_opr.py  icd_mk_shortcut.py  shortcut.bat    my_module.py    icd_module.py
#   icd_cur_mdl_opr.txt 

# 参考  C#_sample\SxFile/Sxfile/SxFile.cs
#       idc_cur_mdl_del.py3

# 履歴
# 2021.5.12     「訂正番号付OLD保存」追加
# 2021.5.14     「V7L7保存」追加
# 2021.5.31     「Activ Model確認」でパーツ付加情報を表示
# 2022.2.6      指定フォルダーにショートカットを作成するメニューを追加
# 2023.10.8     一部パーツ操作を統合
# 2023.10.17    List data(.sby)ファイルもコピー
# 2024.7.11     「閲覧」でpdfやtif、icd  Fileを開けるように改良
# 2024.8.17     外部パーツ一括バックアップ追加


# ICADを操るためのおまじない
import clr
clr.AddReference('sxnet')
from sxnet import *

import tkinter as tk
from tkinter import *
from tkinter import messagebox
from tkinter import filedialog
import subprocess
import stat
#import numpy as np
import os
#import threading
#from time import sleep
import datetime as dt
import time
import shutil
import codecs
import glob

import icd_module as imd
import my_module as mmd
import my_tk as mtk
#import zen_han      #全角<-->半角変換


# Global変数
my_fn= os.path.basename(__file__)       # ...py
icad_path= SxSys.getDir().replace('\\','/')+ '/'
my_save_fn= icad_path+ my_fn.replace('.py','.dat')    # c:\icadsx\....dat

if my_fn.find('_.py')> -1:    # 開発Version
    my_ini_fn= my_fn.replace('_.py','.ini')    # ....ini
else:
    my_ini_fn= my_fn.replace('.py','.ini')    # ....ini

print(my_ini_fn)    ###

entry_txt= []
fn_list= [] # 外部パーツリスト
ext_idx= 0      # 外部パーツIndex

act_mdl_path= ''    # y:/test/
act_mdl_nm= ''      # 81016000001
act_mdl_cmnt= ''    # ラベラー入口Ｐ変ホイール
act_fp_fn= ''       # y:/test/81016000001.icd


#Editorの設定  
edit_fn = 'editor.ini'

if os.path.exists(edit_fn):      # fnが存在するなら
    fp = open(edit_fn, 'r')
    for line in fp.readlines():
        if line.find('#') > -1:  # #が含まれてるなら
            continue
        line = line.rstrip()    # 行末の改行を削除
        tmp = line.split(',')
        if tmp[0] == 'editor':
            editor = tmp[1]
else:
    editor = 'notepad'


#----------------------------------------------------------------------------------
# Buttonが押された時の処理
#----------------------------------------------------------------------------------
def push_read_default():    # 初期設定ファイル読込
    global sby_fld
    with codecs.open(my_ini_fn,'r','utf-8') as fp:
        tmp0= fp.readlines()    # 全行がリストとして読み込まれる。改行(\r\n)付き
    
    #print(tmp0)
    for tmp1 in tmp0:
        if len(tmp1)== 0:    # 空白行
            continue
        elif tmp1[0]== '#':   # 先頭が「#」の行
            continue
        tmp1 = tmp1.rstrip()    # 行末の改行削除
        tmp= tmp1.split(',')    # List tmp作成　['move_fld', 'c:/ICADSX/gomi/']
        #print(tmp)     ###
        if tmp[0].find('move_fld') > -1:
            set_entry(1, tmp[1])
        elif tmp[0].find('copy_fld') > -1:
            set_entry(2, tmp[1])
        elif tmp[0].find('bak_fld') > -1:
            set_entry(4, tmp[1])
        elif tmp[0].find('old_fld') > -1:
            set_entry(5, tmp[1])
        elif tmp[0].find('sby_fld') > -1:
            sby_fld= tmp[1]

    #print(sby_fld)  ###



def push_actmdl():  # Activ Model確認
    global act_mdl_path, act_mdl_nm, act_mdl_cmnt, act_fp_fn
    act_mdl_nm, act_mdl_path, act_fp_fn= imd.get_active_model_name()    # Acviveなモデルファイル名取得
     
    if act_mdl_nm== None:
        #print('\n   Activeなモデルがありません\007\n')
        #res= messagebox.showwarning(
        #        title="Active Model not Exist",
        #        message="Activeなモデルがありません")
        res= mtk.warning("Activeなモデルがありません")    # 警告
        return
        #entry[0].delete(0,tk.END)   # Acriveなモデル名を記入
        #entry[0].insert(0,mdl_name)
    else:
        act_mdl_inf= imd.icd_toppart_get_inf()  # パーツ名、パーツコメント、パーツ付加情報の辞書
        # act_mdl_inf['p_name']:    パーツ名
        # act_mdl_inf['p_cmnt']:    パーツコメント
        # act_mdl_inf['User_Type']:    区分　pf情報 etc
        #   .....
        act_mdl_cmnt= act_mdl_inf['p_cmnt']

        set_entry(0, act_mdl_nm+'.icd')
        set_entry(7, act_mdl_nm+'IN.icd') # 全パーツ取り込み　Default
        set_entry(8, act_mdl_nm+'.zip') # 圧縮ファイル名　Default
              
        print(' //Active Modelの諸情報　表示//')

        #print(' Path: %s  Name: %s  Comment: %s' % (act_mdl_path, act_mdl_nm, act_mdl_cmnt))
        for key in act_mdl_inf:
            print(' %s: %s' % (key, act_mdl_inf[key]))

        #cmd = 'py icd_icd_ext.py '+ mdl_full_path_name + ' 2 cur'   # 個別表示
        #result = subprocess.call(cmd,shell=True)
        #print('\n    表示を終了しました\n')
        


def push_help():
    cmd = editor + ' icd_cur_mdl_opr.txt'
    result = subprocess.Popen(cmd,shell=True)

# 読み取り専用解除
def push_del_read_only():
    set_entry_act_mdl() # Active Model再取得
    re_read = 0     # 再読み込みFlag
    if not os.access(act_fp_fn, os.W_OK):   # 書き込み可能でないなら
        re_read = 1
        os.chmod(act_fp_fn, stat.S_IWRITE)     # 読み取り専用属性解除(parmision)
        print('\n   読取専用属性(parmision)解除しました\n')
    else:
        print('\007\n   読み書き可能(parmision)なファイルです。\n')   
            
    f_inf = imd.icd_fmdl_get_inf(act_fp_fn)
    #print(f_inf)

    if f_inf['flg_exc'] == 'True':    # 誰かが開いているかも
        cmd = 'c:/ICADSX/bin/DBLOCK.EXE /DISP ' + act_fp_fn
        #print(cmd)
        os.system(cmd)
        re_read = 1
        cmd = 'c:/ICADSX/bin/DBLOCK.EXE /OFF ' + act_fp_fn
        os.system(cmd)
        print('\n   Model Lockを解除しました\n')
    else:
        print('\n   %s が使用中です\n' % f_inf['owner'])


    if re_read == 1:
        SxModel.getActive().delete(False)     # modelを閉じる
        time.sleep(1)     # 1秒待ち
        print(act_fp_fn)
        SxFileModel(act_fp_fn).open(False)     # # model開く   読み取り専用OFF
        print('\n   読み取り専用を解除し、再読み込みしました\007\n')




#  への移動(削除)
def push_move():    
    set_entry_act_mdl() # Active Model再取得

    move_fld = entry[1].get()   # 移動フォルダー取得
    if ask_mkdir(move_fld):
        if messagebox.askyesno(title='削除（移動）',
                message=('%s を削除（%sへの移動）しますか？' % (act_mdl_nm,move_fld))):

            shutil.move(act_fp_fn,(move_fld + act_mdl_nm + '.icd'))    # File名も指定すると上書き
            print('\n   %s を %s へ移動(削除)しました。\n' % (act_mdl_nm, move_fld))

    else:
        print('\n   %s への移動(削除)を中止しました。\n' % move_fld)
        return None

    
# Active Modelを　へのコピー
def push_copy():
    set_entry_act_mdl() # Active Model再取得
    copy_fld = entry[2].get()
    if ask_mkdir(copy_fld):
        shutil.copy2(act_fp_fn, copy_fld)    # 第二引数がディレクトリの場合、同じファイル名でコピー
        print('\n   %s.icd を %s へコピーしました。(ロック解除)\n' %  (act_mdl_nm, copy_fld))
        cmd = 'c:/ICADSX/bin/DBLOCK.EXE /OFF ' + copy_fld + act_mdl_nm + '.icd'   # Model Lock 解除
        os.system(cmd)

        ss= '%s.icd を %s へコピーしました。(ロック解除)' %  (act_mdl_nm, copy_fld)
        res= mtk.information(ss)
        
        # zip_name Entry[8]に圧縮ファイル名候補を記入
        zip_nm= act_mdl_nm+ '.zip'
        set_entry(8,  zip_nm)
    else:
        print('\n   %s へのコピーを中止しました。\n' % copy_fld)
        ss= ' %s へのコピーを中止しました。\n' % copy_fld
        res= mtk.information(ss)

        return None



def push_shortcut():
    set_entry_act_mdl() # Active Model再取得
    sc_fld = entry[3].get() 

    if ask_mkdir(sc_fld):
        inf_dic = imd.icd_toppart_get_inf() #Active MOdel名、コメント、Part付加情報を取得する関数
        if not 'User_Type' in inf_dic:
            res= mtk.warning("パーツ付加情報が未入力です")    # 警告
            #warning('パーツ付加情報が未入力です')
            #print('\n   パーツ付加情報が未入力です\007\n')
            #return
        
        for tmp_fn in glob.glob(sc_fld+'*.lnk'):
            p_nm = tmp_fn.split('_')[0]
            print(p_nm, inf_dic['p_name'])
            if p_nm.find(inf_dic['p_name']) > -1:
                if messagebox.askyesno(title='同名リンク',
                        message='同名リンクがあります。上書きしますか'):

                    os.remove(tmp_fn)   # 元のリンク削除
                    time.sleep(1)     # 1秒待ち
                    break
                else:  # 「n」ShortCut作成中止
                    print('\n   ショートカットの作成を中止しました\n')
                    return
        
        # 同パーツ名のリンクがなかった,もしくは上書き指示
        fn_lnk = '"%s%s_%s.lnk"' % (sc_fld, inf_dic['p_name'], inf_dic['p_cmnt'])
        #print(fn_lnk, fp_fn)
        mmd.mk_shortcut(fn_lnk, act_fp_fn)  # ShorCut作成
        fn_ext0 = os.path.basename(act_fp_fn)   # File名抽出
        fn_ext1 = os.path.basename(fn_lnk)   # File名抽出
        messagebox.showinfo(title='リンク作成',
                message='%sのリンクを作成しました' % fn_ext0,
                detail= '%s' % fn_ext1)

        
    else:
        print('\n   %s のリンク作成を中止しました。\n' % sc_fld)
        #return None
        
# Active Model BackUp
def push_backup():      # Back Up
    set_entry_act_mdl() # Active Model再取得
    backup_fld = entry[4].get()
    if ask_mkdir(backup_fld):
        #set_entry(0, mdl_name)
        ss_date= get_date()
        fn0 = '%s%s.icd' % (act_mdl_nm, ss_date) 
        #fn0 = os.path.basename(mdl_full_path_name.replace('.icd',tmp))
    
        fp_fn = backup_fld+ fn0
        #fn = bak_fld + fn0
        shutil.copy2(act_fp_fn, fp_fn )  #コピーする
        # Pythonのフォルダーにファイルができるので移動する
        print('\n   %s にコピーしました\n' % fp_fn)
        fn_ext = os.path.basename(fn0)   # File名抽出
        
        messagebox.showinfo(title='バックアップ',
                message='%s 名でバックアップしました。' % fn_ext)
                #detail= '%s' % fn_ext1)

    else:
        print('\n   %s へのコピーを中止しました。\n' % backup_fld)
        return None

def push_old_save():    #訂正番号付保存 
    set_entry_act_mdl() # Active Model再取得
    old_fld = entry[5].get()
    if ask_mkdir(old_fld):
        teisei = imd.teisei_is(0)   # Active Modelの訂正番号
        # print(teisei)
        if teisei < 0:
            print('部品図、組図、計画図ではないようです')
            return
        else:
            mdl_name, mdl_path, mdl_full_path_name = imd.get_active_model_name()    # Acviveなモデルファイル名取得
            fn = mdl_name + str(teisei)
            save_fp_fn = old_fld + '\\'+ fn + '.icd'
            shutil.copy(mdl_full_path_name, save_fp_fn)
            print('\n   %s を %s へコピーしました\n' % (mdl_full_path_name, save_fp_fn))
            # 読み専解除、モデルロック解除
            time.sleep(1)     # 1秒待ち
            os.chmod(save_fp_fn, stat.S_IWRITE)     # 読み取り専用属性解除(parmision)
            cmd = 'c:/ICADSX/bin/DBLOCK.EXE /OFF ' + save_fp_fn
            os.system(cmd)
            print('\n   %s の読取専用属性及びロックを解除しました' % save_fp_fn)
            fn_ext = os.path.basename(save_fp_fn)   # File名抽出
            messagebox.showinfo(title='訂正番号付保存',
                    message='%s で保存しました。' % fn_ext)
                    #detail= '%s' % fn_ext1)
    else:
        print('\n   %s へのコピーを中止しました。\n' % old_fld)
        return None



def get_ext_parts_list(tree,level):
    global ext_idx
    for i in range(level):
        ss = str(ext_idx)+'  '+tree.inf.path + "\\" + tree.inf.name + " : "+tree.inf.comment
        tmp = tree.inf.path + '\\' + tree.inf.ref_model_name
        if tree.inf.is_external and (tmp in fn_list) == False:  # 外部パーツでfn_listに未登録
          #print(ss)
          #tmp = tree.inf.path + '\\\\' +tree.inf.name + '.icd'
          fn_list.append(tmp+ '.icd')   # 
          #fn_list.append(tmp)   #global
          ext_idx+=1

        # 子パーツが存在する場合、再帰的に処理する。
    if tree.child_list != None:
        for tree in tree.child_list:
            get_ext_parts_list(tree,level + 1)

def push_acp(): # 外部パーツコピー(icd_assy_cp_tree.py3より移植)
    global ext_idx , fn_list
    set_entry_act_mdl() # Active Model再取得
    ext_pcp_fld = entry[6].get()
    if ask_mkdir(ext_pcp_fld):
        #cmd = 'py icd_assy_cp_tree.py3 ' + ext_pcp_fld
        #result = subprocess.Popen(cmd,shell=True)
        
        # アクティブWF内の最上位パーツからパーツ階層情報を取得する。
        ext_idx = 1
        SxSys.setDim(True)             #3Dに切り替え
        wf = SxWF.getActive()
        if wf == None:
        #model = SxModel.getActive()     # Activeなモデルを取得
        #if model== None:
            res= mtk.warning(' Activeなモデルがありません。')
            #print('Activeなモデルがありません')
            return  False
    
        #time.sleep(0.5)   #!!!
         
        tree = wf.getInfPartTree()    # Tree View 情報取得 
        fn_list = []  #Gloval 初期化
        # 全階層パーツ名を取得する。fn_list
        get_ext_parts_list(tree, 0)
        
        # 現モデルもリストに追加
        model = SxModel.getActive()
        inf_model = model.getInf()
        fp_fn = inf_model.path + '\\' + inf_model.name+ '.icd'     # s:/81026000001.icd
        #fp_fn = inf_model.path + '\\' + inf_model.name     # 拡張子無し s:/81026000001
        fn_list.append(fp_fn)
        # View Listがあれば追加
        fp_view = fp_fn.replace('icd', 'ivw')    # s:/81026000001.ivw
        if os.path.exists(fp_view):
            fn_list.append(fp_view)

        # *.sby Fileのコピーを問い合わせる
        sby_fn= inf_model.name+ '.sby'
        sby_fp_fn= sby_fld+ sby_fn
        if os.path.exists(sby_fp_fn)== True:
            if messagebox.askyesno(title='%s Copy' % sby_fn,
                    message='%s を %s にコピーしますか?' %  (sby_fn, ext_pcp_fld)):
                fn_list.append(sby_fp_fn)   

        
        # c:/zip/ Folder 削除?
        if messagebox.askyesno(title='%s内削除' % ext_pcp_fld,
                message='%sを削除しますか?' % ext_pcp_fld):

            cmd = 'del /S /F /Q %s*' % ext_pcp_fld.replace('/','\\')
            os.system(cmd)
            shutil.rmtree(ext_pcp_fld)
            time.sleep(1)     # 1秒待ち
            os.mkdir(ext_pcp_fld)

        fn_list1= sorted(set(fn_list))  # 重複を削除してソートしたリストを返す
        nn= len(fn_list1)               # 2024.1.21

        if messagebox.askyesno(title='File Copy',
                message='%d 個のファイルをCopyしますか?' % nn):
            #if yn == '' or yn == 'y':
            cnt= 0 
            for fp_fn0 in fn_list1:
                #fp_fn0= fn0 + '.icd'   # s:/81026011001.icd
                fn= os.path.basename(fp_fn0)    # 81026011001.icd
                tmp= ext_pcp_fld+ fn   # c:/zip/81026011001.icd
                #print(tmp)  ####
                if not os.path.exists(tmp):
                    shutil.copy2(fp_fn0, ext_pcp_fld) # パーミッションもメタデータもコピーする
                    print('     %s をコピーしました' % fp_fn0)
                    cnt+= 1     
                    # iCAD Model Lockを解除 
                    fn1 = ext_pcp_fld + fn
                    #fn1 = ext_pcp_fld + os.path.basename(fn)
                    cmd = 'c:/ICADSX/bin/DBLOCK.EXE /DISP ' + fn1  # iCAD Model Lock表示
                    proc = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
                    byte = proc.stdout.readline()
                    line = byte.decode('unicode-escape') 
                    #print(line)
                    if line.find('ON') > -1 and os.access(fn1, os.W_OK):  # 2022.5.16 File Permission 書込可 の時だけ実施
                        print('    %s のiCAD Model Lockを解除します\007\n' % fn)
                        cmd = 'c:/ICADSX/bin/DBLOCK.EXE /OFF ' + fn1  # iCAD Model Lock(読み取り専用）解除
                        os.system(cmd)
                else:   #if os.path.exists(fn):
                    print('同名ファイル %s はスキップしました' % fp_fn0)
                    continue
          
            if cnt!= 0:
                messagebox.showinfo(title='外部パーツコピー',
                    message='%d 個のファイルをコピーしました。' % cnt)
                    #detail= '%s' % fn_ext1)
            else:
                messagebox.showinfo(title='外部パーツコピー',
                    message='全てのファイルをスキップしました。')
            
            # zip_name Entry[8]に圧縮ファイル名候補を記入
            zip_nm= act_mdl_nm+ '.zip'
            set_entry(8,  zip_nm)

            return True

    else:   # if ask_mkdir(ext_pcp_fld):
        print('\n   %s へのコピーを中止しました。\n' % ext_pcp_fld)
        return False
        #return None


def push_takein():  # 全パーツ取り込み
    inf_dic = imd.icd_toppart_get_inf() #Active MOdel名、コメント、Part付加情報を取得する関数
    model = SxModel.getActive()
    #model.save()    # Active Modelを保存しておく
    inf_model = model.getInf()
    # 元ファイル名
    fp_fn0 = inf_model.path + '\\'+ inf_model.name + '.icd'

    # 取り込みファイル名
    new_fn= entry[7].get()

    # Active Modelとの整合性チェック　2024.7.13
    if new_fn.find(inf_model.name) < 0:  # 
        if not(mtk.question_yn(' %s と %s は関係ありませんがいいですか。'% (new_fn, inf_model.name))):
            push_actmdl()  # Activ Model確認
            return

    model.save()    # Active Modelを保存しておく
    ver = 0; level = 0  # Default
    # model.saveに渡す場合は「\」を使う
    path= entry[6].get().replace('/', '\\')    # c:\zip\

    SxSys.setDim(True) #3Dに切り替え 3D切り替え
    wf = SxWF.getActive()         # Activeな3D空間のwfインスタンス作成
    part_lst = wf.getPartList()   # 全ての3次元パーツを取得
    for part in part_lst:
        pinf = part.getInfDetail()      # パーツ詳細情報取得
        if pinf.is_external:    #true:外部パーツ  false:内部パーツ
            part.takeIn(True, True)     # all , alllevel
     
    #print(path, new_fn, inf_dic['p_cmnt'], ver, level) ####

    model.save(path, new_fn, inf_model.comment, ver, level)
    model.delete(False)    #モデルを閉じる(保存確認メッセージを出さない)

    # View ListがあればCopy
    fp_view = fp_fn0.replace('icd', 'ivw')    # s:/81026000001.ivw
    if os.path.exists(fp_view):
        shutil.copy2(fp_view, path) 

    # zip_name Entry[8]に圧縮ファイル名候補を記入
    zip_nm= act_mdl_nm+ 'IN.zip'
    set_entry(8,  zip_nm)
    
    print('\n   全パーツの取り込みを完了しました\007\n')
    if v_takein.get():   # 再読み込みにチェックあり
        messagebox.showinfo(title='全パーツ取込',
            message='全パーツの取り込みを完了しました。',
            detail= '%sを再読み込みします。' % fp_fn0)
        # 元ファイル読み込み
        file = SxFileModel(fp_fn0)
        model = file.open(False)    # 読み取り専用OFF

    else:   # チェックなし
        messagebox.showinfo(title='全パーツ取込',
            message='全パーツの取り込みを完了しました。')



def push_rosort(): # 読み取り専用ファイル振り分け
    sv_fld = entry[6].get()
    rdo_fld = sv_fld + 'ReadOnly'
    if not os.path.exists(rdo_fld):
        os.mkdir(rdo_fld)   # 読み取り専用ファイル保存フォルダー作成
        
    i = 0
    for fp_fn in mmd.find_all_files(sv_fld,'.icd','cur'):
        #print(str(i) + ' ' + fp_fn)
        if not os.access(fp_fn, os.W_OK):   # 書き込み可能でないなら　読み取り専用ファイル
            shutil.move(fp_fn, rdo_fld)
            print('     %d  %s を移動しました' % (i, fp_fn))
            i += 1
    if i>0:
        messagebox.showinfo(
            title= '読取専用ファイル振分',
            message= ('%d 個のファイルを振り分けました' % i))
            #detail= ('ファイル名: %s' % fn)):
            #print(res)
    
    else:
        messagebox.showinfo(
            title= '読取専用ファイル振分',
            message= ('読取専用ファイルはありませんでした。'))
        shutil.rmtree(rdo_fld)
             


def push_folder():  # Folder閲覧 選択ファイルを開く
    fld0= entry[6].get()
    copy_fld= mmd.shape_fld(fld0)   # Folder整形
    #print(copy_fld)
    if copy_fld== None:
        return

    fTyp = [("data File","*.*")]
    #iDir = os.path.abspath(os.path.dirname(__file__))
    iDir = os.path.abspath(os.path.dirname(copy_fld))

    #fp_fn = filedialog.askdirectory(initialdir=iDir)    # ハングアップ 使えない
    fp_fn = filedialog.askopenfilename(filetypes=fTyp, initialdir=iDir)
    # 2024.7.11 追記
    if fp_fn == '': # キャンセルしたら
        return

    cmd= fp_fn
    print(cmd)
    if cmd.find('.icd')> -1 or cmd.find('.MDL')> -1 or cmd.find('.pdf')> -1 or cmd.find('.tif')> -1 or cmd.find('.TIF')> -1:
        try:
            result = subprocess.call(cmd,shell=True)
        except:
            res= mtk.warning('%s を開けませんでした' % fp_fn)

    elif cmd.find('.sby')> -1: 
        zuban_list= mmd.sby_anl(fp_fn)
        
        print('\n整理番号     図番          品名     削除マーク\n')
        for tmp in zuban_list:
            #print(tmp)
            #cmnt= zen_han.Han2Zen(tmp[2])
            #print(cmnt)
            print('%4s  %12s  %15s  %s' % (str(tmp[0]), str(tmp[1]), str(tmp[2]), tmp[3]))

    else:
        res= mtk.warning('%s を開けませんでした' % fp_fn)


def push_del_zip(): # 削除
    copy_fld = entry[6].get()
    if messagebox.askokcancel(title='削除',
            message='%s内を削除します' % copy_fld):
    
        cmd = 'attrib -R /S ' + copy_fld + '*.*'    # File読み取り専用属性を解除しないと削除できない 
        os.system(cmd)
        shutil.rmtree(copy_fld)    # Folder削除
        time.sleep(1)     # 1秒待ち
        os.mkdir(copy_fld)     # Folder作成

        print('\n   %s内を削除しました\n' % copy_fld)
    #else:
    #    return


# 圧縮
def push_cmp_zip():
    global act_mdl_path, act_mdl_nm, act_mdl_cmnt, act_fp_fn # Y:\test, cur-mdl-opr1, コメント_ActiveModel
    copy_fld0 = entry[6].get()
    
    fn= entry[8].get()  # 拡張子あり
    (fn0, ext) = os.path.splitext(fn)   # 拡張子なし
    fp_fn= copy_fld0+ fn # 圧縮ファイル(Full Path)
    #print(fp_fn)   #    
    #if messagebox.showinfo(
    if os.path.exists(fp_fn):   # 既にzipファイルがある
        messagebox.showinfo(
            title= '圧  縮',
            message= '既に圧縮ファイルが存在するので中止します。',
            detail= ('ファイル名: %s' % fn))
        return False

    elif messagebox.askyesno(
        title= '圧  縮',
        message= ('%s 内を圧縮します' % copy_fld0),
        detail= ('ファイル名: %s' % fn)):
        shutil.make_archive(icad_path+fn0, format= 'zip', root_dir = copy_fld0)  # 圧縮する　Icad Folder使用
        # Pythonのフォルダーにファイルができるので移動する
        time.sleep(1)
        shutil.move(icad_path+fn, copy_fld0)
        # インフォメーション
        ss= '%sに圧縮しました' % fn
        mtk.information(ss, ss_detail= '', ttl= '圧縮')
        return True
    else:
        print('\n   圧縮を中止しました\007\n') 
        return False


def push_disp_zip():
    copy_fld = entry[2].get()
    cmd = 'py icd_icd_ext.py %s 1 cur' % copy_fld
    result = subprocess.call(cmd,shell=True)
    print('\n    表示を終了しました\n')
    #files = os.listdir(copy_fld0)       # lsもどき
    #for file in files: print(file)
    #print('\n\n')

#----------------------------------
#   図面印刷、PDF出力
#----------------------------------
def push_plot():
    cmd = 'py icd_plot.py'
    result = subprocess.Popen(cmd,shell=False)

# 外部パーツ一括バックアップ
def push_backup2():
    if push_acp():  # 外部パーツコピー完了
        v_date.set(True)    # 日付にチェック
        set_zip_name()      # 圧縮ファイル名セット 
        if push_cmp_zip():  # 圧縮完了
            backup_fld = mmd.shape_fld(entry[4].get())  # BuckUp先フォルダー整形済み
            fld0 = mmd.shape_fld(entry[6].get())        # コピー元フォルダー
            fp_fn0= fld0+ entry[8].get()  # 圧縮ファイル名 拡張子あり
            #ss= '%s を %s にコピーします' % (fp_fn0, backup_fld)
            #if mtk.question_yn(ss):
            shutil.copy2(fp_fn0, backup_fld)  #コピーする
            ss= '%s を %s にバックアップしました' % (fp_fn0, backup_fld)
            print('\n   '+ ss)
            mtk.information(ss)
            return True
        
        return False




#-------------------------------
#  その他の関数
#-------------------------------
def set_zip_name():   # チェックボタンのイベント
    tmp= act_mdl_nm
    ss_date= get_date()
    
    if v_cmnt.get():    # コメントを追加
        tmp= '%s_%s' % (tmp, act_mdl_cmnt)
    if v_date.get():    # 現在時刻を追加
        tmp= tmp+ss_date

    zip_name= tmp+'.zip'

    set_entry(8, zip_name)


# 現在時刻文字列を取得
def set_entry_act_mdl():
    global act_mdl_path, act_mdl_nm, act_mdl_cmnt, act_fp_fn
    act_mdl_nm, act_mdl_path, act_fp_fn = imd.get_active_model_name() # Acviveなモデルファイル名取得(拡張子無し)
    if act_mdl_nm == None:
        res= mtk.warning('Fileが開かれていません')
        #print('\n   Fileが開かれていません\n')
        #warning('Fileが開かれていません')
        return
    set_entry(0, act_mdl_nm+'.icd')


def get_date():
    #d= dt.datetime.today()
    ss_date= time.strftime('_%y%m%d%H')
    #ss_date= d.strftime('_%y%m%d%H')
    #ss_date= '_%s%s%s%s' % (ss_year, ss_month, ss_day, ss_hour)
    return ss_date


#  Entry取得
def get_ent():
    nn_ent= len(entry_txt)
    for i in range(nn_ent):
        entry_txt[i]= entry[i].get()
        print(entry_txt[i]) ####
    return entry_txt

# Folder存在確認してから作成
def ask_mkdir(folder):
    if not os.path.exists(folder):    # 存在しないとき
        print('\007')
        res= messagebox.askyesno(
                title=None,
                message='フォルダーが存在しません',
                detail='%s を作成しますか' % folder)

        if res: # OK BUtton True Folder作成
            os.makedirs(folder)
            return True
        else:
            return False
    else: return True   # 存在したらTruを返す


def set_my_ent_data(): # my_save_fnよりEntry detaを読み込んで書き込み
    fp = open(my_save_fn, 'r')
    lines = fp.readlines()
    fp.close()
    if len(lines) < 9:  #  古いと判断
        return False

    i= 0
    for line in lines:
        line = line.rstrip()    # 行末の改行削除
        if line.find('#') > -1:  # #が含まれてるなら
            continue

        tmp = line.split('= ')
        if len(tmp) < 2:
            i+=1
            continue

        if line.find('entry') > -1: # Entry行
            #if len(tmp) == 2: 
            set_entry(i, tmp[1])
            i+= 1
    return True
    
def set_entry(idx, ss): # Entryに文字列を挿入
    try:
        entry[idx].delete(0,tk.END)
        entry[idx].insert(0,ss)
    except:
        return

def set_entry2(ent, ss): # Entryに文字列を挿入
    ent.delete(0,tk.END)
    ent.insert(0,ss)

def set_entry3(entry_txt):
    i= 0
    for ss in entry_txt:
        set_entry(i, ss)
        i+=1


def save_my_ent_data():    # Entry 設定値保存(個人用)
    ss = ''
    for i in range(len(entry)):
        tmp= entry[i].get()
        #print(tmp, len(tmp))  ####
        if len(tmp)< 1:
            #print('tmpが空です')
            tmp= '--'
        ss = ss + 'entry[%d]= %s\n' % (i, tmp)

    fp = open(my_save_fn,'w')
    fp.write(ss)
    fp.close()    

#def warning(ss):
#    res = messagebox.showwarning(title="warning!", message= ss)
    

def on_closing():       # 終了時の処理
    save_my_ent_data()
    ss_geom = root.geometry() 
    mmd.save_geometry(save_fn_geom, ss_geom)

    #print('\n   %s を終了しました\n' % tmp_fn)
    print('\n   %s を終了しました\n' % my_fn)

    root.destroy()


#************************************
# ボタン等の部品配置
#************************************
nl = 15
root = tk.Tk()
root.attributes("-topmost", True)    # 常に前面に表示
root.configure(bg='RoyalBlue4')
root.title(my_fn)  #タイトル
save_fn_geom = my_fn.replace('.py', '.ini')
ss_geom = mmd.read_geometry(save_fn_geom)
if ss_geom == None:
    ss_geom = '245x%d+1000+0' % (nl*30)

root.geometry(ss_geom)

btn_bcol = 'grey21'     #ボタン背景色
btn_tcol = 'white'      #ボタン文字色
label_bcol = 'khaki3'   #ラベル背景色
label_tcol = 'black'    #ラベル文字色
e_bcol = 'ivory2'       #Entry背景色
#e_bcol = 'khaki4'

x0= 10; y0= 2
dx= 100; dy= 32
px= 2; py= 2
ie= 0   # Entry Index
yl= 0   # 行数 Index
wdt= 20 # Entry幅

# push_actmdlボタン配置
btn = tk.Button(root,text = 'Actmdl確認',command = push_actmdl,bg=btn_bcol,fg=btn_tcol)
btn.place(x=10,y=5)

# push_read_defaultボタン配置　初期設定読込ボタン
btn = tk.Button(root,text = '初期設定読込',command = push_read_default, bg='orange',fg=label_tcol)
btn.place(x=110,y=5)


# push_helpボタン配置
btn = tk.Button(root,text = 'ヘルプ',command = push_help,bg=btn_bcol,fg=btn_tcol)
btn.place(x=195,y=5)
#btn.grid(column=1, row=yl, padx=px, pady=py)
yl+=1

#----------------------------------------------------------------------------------
# Frame1  Active Model操作
frame1 = tk.Frame(root, padx=px, pady=py, bg="RoyalBlue3") 
frame1.place(x=5,y=yl*dy)

btn_txt= ['読専解除再読込','への移動(削除)','   へのコピー   ','ShortCut作成','    Back Up   ',' 訂正付保存 ']#, \
        #'へ外部パーツコピー','へ全パーツ取込']
cmd_txt= [push_del_read_only, push_move, push_copy, push_shortcut, push_backup, push_old_save]#, \
        #push_acp, push_takein]
ni= len(btn_txt)
entry= []

for i in range(ni):
    entry.append(tk.Entry(frame1, width=wdt,justify="right",bg=e_bcol))
    entry[ie].insert(0,str(ie)) 
    entry[ie].grid(column=1,row=i, padx=px, pady=py); ie+= 1

    btn= tk.Button(frame1,text = btn_txt[i],command= cmd_txt[i],bg=btn_bcol,fg=btn_tcol) #ボタンの作成
    btn.grid(column=2,row=i, padx=px, pady=py)
    yl+=1 
# end of Frame1-------------------------------------------------------------------


#----------------------------------------------------------------------------------
# Frame2  c:/zip/ Folder操作
#----------------------------------------------------------------------------------
#print(yl)  #"RoyalBlue2"
frame2 = tk.Frame(root,width=230, height=188, padx=px, pady=py, bg="orange2") 
frame2.place()
#frame2.grid()
frame2.place(x=5,y=yl*dy)

# Folder選択 filedialogを開く
entry.append(tk.Entry(frame2, width=wdt,justify="right",bg=e_bcol))
entry[ie].insert(0,str(ie)) #ie= 6
entry[ie].place(x=5, y=0); ie+=1
#entry[ie].grid(column=0,row=0, padx=px, pady=py); ie += 1

x1= 135
#btn= tk.Button(frame2,text= '閲覧(Dialog)',command= push_folder, bg=btn_bcol,fg=btn_tcol) #ボタンの作成
btn= tk.Button(frame2,text= '閲覧(Dialog)',command= push_folder, bg='pink',fg='black') #ボタンの作成
btn.place(x=x1, y=0)
#btn.grid(column=1,row=0, padx=px, pady=py)

# 外部パーツコピー
btn= tk.Button(frame2,text= '外部パーツコピー',command= push_acp, bg=btn_bcol,fg=btn_tcol) #ボタンの作成
btn.place(x=x1, y=dy)

# 全パーツ取込
v_takein= tk.BooleanVar()   # 論理値型の変数 Instance
v_takein.set(True)          # 初期値  
chkb_takein= tk.Checkbutton(frame2,text='取込後再読込',variable=v_takein)
chkb_takein.place(x=5,y=dy+14)

y1= 2*dy
entry.append(tk.Entry(frame2, width=wdt,justify="right",bg=e_bcol))
entry[ie].insert(0,str(ie)) 
entry[ie].place(x=5, y=y1+8); ie+=1
btn= tk.Button(frame2,text= '全パーツ取込',command= push_takein, bg=btn_bcol,fg=btn_tcol) #ボタンの作成
btn.place(x=x1, y=y1)

# 閲覧  区分、Version、Fname、Comment 
y1= 3*dy
btn= tk.Button(frame2,text= '閲覧(Shell)',command= push_disp_zip, bg=btn_bcol,fg=btn_tcol) #ボタンの作成
btn.place(x=25, y=y1)
#btn.grid(column=0,row=1, padx=px, pady=py)

btn= tk.Button(frame2,text= '削除',command= push_del_zip, bg=btn_bcol,fg=btn_tcol) #ボタンの作成
btn.place(x=100, y=y1)
#btn.grid(column=1,row=1, padx=px, pady=py)
btn= tk.Button(frame2,text= '読専振分',command= push_rosort, bg=btn_bcol,fg=btn_tcol)
btn.place(x=150, y=y1)


btn= tk.Button(frame2,text= '圧縮',command= push_cmp_zip, bg=btn_bcol,fg=btn_tcol) #ボタンの作成
btn.place(x=180, y=dy*4)
v_date = tk.BooleanVar()   # 論理値型の変数 Instance
v_date.set(False)          # 初期値品名記入なし 
cb_date = tk.Checkbutton(frame2,text='日付付',variable=v_date, command= set_zip_name)
cb_date.place(x=5, y=dy*4)
#cb_date.grid(column=0,row=2, padx=px, pady=py)
v_cmnt = tk.BooleanVar()   # 論理値型の変数 Instance
v_cmnt.set(False)          # 初期値品名記入なし 
cb_cmnt = tk.Checkbutton(frame2,text='Comment付',variable=v_cmnt, command= set_zip_name)
cb_cmnt.place(x=70, y=dy*4)
#cb_cmnt.grid(column=1,row=2, padx=px, pady=py)


# 圧縮ファイル名格納 Entry
entry.append(tk.Entry(frame2, width=36,justify="right",bg=e_bcol))
entry[ie].insert(0,str(ie)) 
entry[ie].place(x=0,y= dy*5)
#entry[ie].grid(column=0,row=3, padx=px, pady=py); ie += 1

btn= tk.Button(root,text= '図面印刷(PDF)',command= push_plot, bg=btn_bcol,fg=btn_tcol) #ボタンの作成
btn.place(x=140, y=dy*13)
#print(ie)   ####
btn= tk.Button(root,text= '外部パーツ一括Buck Up',command= push_backup2, bg='pink',fg='black')
#btn= tk.Button(root,text= '外部パーツ一括Buck Up',command= push_backup2, bg=btn_bcol,fg=btn_tcol)
btn.place(x=0, y=dy*13)

#--------------------------------
#起動時の処理
#--------------------------------
# 初期設定ファイル読込 Entry書き込み、sby_fld 設定
push_read_default()

# 保存された設定データ読込引数
my_save_fn0= my_save_fn # 元祖my_save_fn
if len(sys.argv)== 2:   # 引き数2個 
    my_save_fn= sys.argv[1]  # 起動時にmy_save_fnが指定された場合

# my_save_fn があれば読み込んで Entry書き込み
if os.path.exists(my_save_fn) and set_my_ent_data():   #True:成功 False:失敗
    print('     設定データ %s を読み込みました' % my_save_fn)


model = SxModel.getActive()     # Activeなモデルを取得
if model== None:
    res= mtk.warning('Activeなモデルがありません。')
else:
    push_actmdl()
    #mdl_name = model.getInf().name      # 拡張子なし
    #mdl_cmnt = model.getInf().comment


root.protocol("WM_DELETE_WINDOW", on_closing)
root.mainloop()
